Index: /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/documents/document.py
===================================================================
--- /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/documents/document.py	(revision 12269)
+++ /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/documents/document.py	(revision 12270)
@@ -22,8 +22,8 @@
 from zope.component.interfaces import IFactory
 from zope.interface import implementedBy
-from waeup.ikoba.interfaces import MessageFactory as _
 from waeup.ikoba.utils.helpers import attrs_to_fields
 from waeup.ikoba.documents.document import PublicDocumentBase
 from ikobacustom.skeleton.documents.interfaces import ISkeletonDocument
+from ikobacustom.skeleton.interfaces import MessageFactory as _
 
 
Index: /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/documents/export.py
===================================================================
--- /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/documents/export.py	(revision 12269)
+++ /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/documents/export.py	(revision 12270)
@@ -19,8 +19,8 @@
 """
 import grok
-from waeup.ikoba.interfaces import MessageFactory as _
 from waeup.ikoba.utils.helpers import iface_names
 from waeup.ikoba.documents.export import DocumentExporterBase
 from ikobacustom.skeleton.documents.interfaces import ISkeletonDocument
+from ikobacustom.skeleton.interfaces import MessageFactory as _
 
 
Index: /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/documents/interfaces.py
===================================================================
--- /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/documents/interfaces.py	(revision 12269)
+++ /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/documents/interfaces.py	(revision 12270)
@@ -21,6 +21,6 @@
     IIkobaObject,
     ContextualDictSourceFactoryBase)
-from waeup.ikoba.interfaces import MessageFactory as _
 from waeup.ikoba.documents.interfaces import IPublicDocument
+from ikobacustom.skeleton.interfaces import MessageFactory as _
 
 
Index: /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/products/export.py
===================================================================
--- /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/products/export.py	(revision 12269)
+++ /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/products/export.py	(revision 12270)
@@ -19,8 +19,8 @@
 """
 import grok
-from waeup.ikoba.interfaces import MessageFactory as _
 from waeup.ikoba.utils.helpers import iface_names
 from waeup.ikoba.products.export import ProductExporter
 from ikobacustom.skeleton.products.interfaces import ISkeletonProduct
+from ikobacustom.skeleton.interfaces import MessageFactory as _
 
 
Index: /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/products/interfaces.py
===================================================================
--- /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/products/interfaces.py	(revision 12269)
+++ /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/products/interfaces.py	(revision 12270)
@@ -21,6 +21,6 @@
     IIkobaObject,
     ContextualDictSourceFactoryBase)
-from waeup.ikoba.interfaces import MessageFactory as _
 from waeup.ikoba.products.interfaces import IProduct
+from ikobacustom.skeleton.interfaces import MessageFactory as _
 
 
Index: /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/products/product.py
===================================================================
--- /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/products/product.py	(revision 12269)
+++ /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/products/product.py	(revision 12270)
@@ -22,8 +22,8 @@
 from zope.component.interfaces import IFactory
 from zope.interface import implementedBy
-from waeup.ikoba.interfaces import MessageFactory as _
 from waeup.ikoba.utils.helpers import attrs_to_fields
 from waeup.ikoba.products.product import Product
 from ikobacustom.skeleton.products.interfaces import ISkeletonProduct
+from ikobacustom.skeleton.interfaces import MessageFactory as _
 
 