Index: /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/batching.py
===================================================================
--- /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/batching.py	(revision 12274)
+++ /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/batching.py	(revision 12274)
@@ -0,0 +1,45 @@
+## $Id: batching.py 12269 2014-12-20 16:12:59Z henrik $
+##
+## Copyright (C) 2011 Uli Fouquet & Henrik Bettermann
+## This program is free software; you can redistribute it and/or modify
+## it under the terms of the GNU General Public License as published by
+## the Free Software Foundation; either version 2 of the License, or
+## (at your option) any later version.
+##
+## This program is distributed in the hope that it will be useful,
+## but WITHOUT ANY WARRANTY; without even the implied warranty of
+## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+## GNU General Public License for more details.
+##
+## You should have received a copy of the GNU General Public License
+## along with this program; if not, write to the Free Software
+## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
+##
+"""Batch processing for skeleton documents.
+"""
+import grok
+from waeup.ikoba.customers.batching import (
+    CustomerDocumentProcessor, ContractProcessor)
+from ikobacustom.skeleton.customers.interfaces import (
+    ISkeletonCustomerDocument, ISkeletonContract)
+from ikobacustom.skeleton.interfaces import MessageFactory as _
+
+
+class SkeletonCustomerDocumentProcessor(CustomerDocumentProcessor):
+    """A batch processor for ISkeletonCustomerDocument objects.
+    """
+    util_name = 'skeletoncustomerdocumentprocessor'
+    grok.name(util_name)
+    name = _('Skeleton Customer Document Processor')
+    iface = ISkeletonCustomerDocument
+    factory_name = 'waeup.SkeletonCustomerDocument'
+
+
+class SkeletonContractProcessor(ContractProcessor):
+    """A batch processor for ISkeletonContract objects.
+    """
+    util_name = 'skeletoncontractprocessor'
+    grok.name(util_name)
+    name = _('Skeleton Contract Processor')
+    iface = ISkeletonContract
+    factory_name = 'waeup.SkeletonContract'
Index: /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/utils.py
===================================================================
--- /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/utils.py	(revision 12274)
+++ /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/utils.py	(revision 12274)
@@ -0,0 +1,44 @@
+## $Id: utils.py 12223 2014-12-14 08:49:01Z henrik $
+##
+## Copyright (C) 2014 Uli Fouquet & Henrik Bettermann
+## This program is free software; you can redistribute it and/or modify
+## it under the terms of the GNU General Public License as published by
+## the Free Software Foundation; either version 2 of the License, or
+## (at your option) any later version.
+##
+## This program is distributed in the hope that it will be useful,
+## but WITHOUT ANY WARRANTY; without even the implied warranty of
+## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+## GNU General Public License for more details.
+##
+## You should have received a copy of the GNU General Public License
+## along with this program; if not, write to the Free Software
+## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
+##
+"""General helper functions and utilities for the customer section.
+"""
+
+from waeup.ikoba.customers.utils import CustomersUtils
+from ikobacustom.skeleton.interfaces import MessageFactory as _
+
+class SkeletonCustomersUtils(CustomersUtils):
+    """A collection of methods subject to customization.
+    """
+
+
+    DOCTYPES_DICT = {
+        'CustomerSampleDocument': _('Sample Document'),
+        'CustomerPDFDocument': _('PDF Document'),
+
+        'SkeletonSampleDocument': _('Skeleton Document'),
+        }
+
+    CONTYPES_DICT = {
+        'SampleContract': _('Sample Contract'),
+
+        'SkeletonContract': _('Skeleton Contract'),
+        }
+
+    SELECTABLE_DOCTYPES_DICT = DOCTYPES_DICT
+
+    SELECTABLE_CONTYPES_DICT = CONTYPES_DICT
Index: /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/documents/batching.py
===================================================================
--- /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/documents/batching.py	(revision 12273)
+++ /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/documents/batching.py	(revision 12274)
@@ -25,5 +25,5 @@
 
 class SkeletonDocumentProcessor(DocumentProcessorBase):
-    """A batch processor for IHTMLDocument objects.
+    """A batch processor for ISkeletonDocument objects.
     """
     util_name = 'skeletondocumentprocessor'