Index: /main/waeup.ikoba/trunk/src/waeup/ikoba/browser/pages.py
===================================================================
--- /main/waeup.ikoba/trunk/src/waeup/ikoba/browser/pages.py	(revision 12282)
+++ /main/waeup.ikoba/trunk/src/waeup/ikoba/browser/pages.py	(revision 12283)
@@ -964,6 +964,9 @@
     def getImporters(self):
         importers = getAllUtilitiesRegisteredFor(IBatchProcessor)
+        ikoba_utils = getUtility(IIkobaUtils)
         importer_props = []
         for x in importers:
+            if not x.util_name in ikoba_utils.BATCH_PROCESSOR_NAMES:
+                continue
             iface_fields = schema.getFields(x.iface)
             available_fields = []
@@ -1085,6 +1088,8 @@
     def getImporters(self):
         importers = getAllUtilitiesRegisteredFor(IBatchProcessor)
+        ikoba_utils = getUtility(IIkobaUtils)
         importers = sorted(
-            [dict(title=x.name, name=x.util_name) for x in importers])
+            [dict(title=x.name, name=x.util_name) for x in importers
+            if x.util_name in ikoba_utils.BATCH_PROCESSOR_NAMES])
         return importers
 
@@ -1439,7 +1444,9 @@
 
     def getExporters(self):
-        utils = getUtilitiesFor(ICSVExporter)
+        exporter_utils = getUtilitiesFor(ICSVExporter)
+        ikoba_utils = getUtility(IIkobaUtils)
         title_name_tuples = [
-            (util.title, name) for name, util in utils]
+            (util.title, name) for name, util in exporter_utils
+            if name in ikoba_utils.EXPORTER_NAMES]
         return sorted(title_name_tuples)
 
Index: /main/waeup.ikoba/trunk/src/waeup/ikoba/customers/batching.py
===================================================================
--- /main/waeup.ikoba/trunk/src/waeup/ikoba/customers/batching.py	(revision 12282)
+++ /main/waeup.ikoba/trunk/src/waeup/ikoba/customers/batching.py	(revision 12283)
@@ -560,5 +560,5 @@
     grok.name(util_name)
 
-    name = _('Sample Contract Processor')
+    name = _('Customer Sample Contract Processor')
     iface = ISampleContract
     factory_name = 'waeup.SampleContract'
Index: /main/waeup.ikoba/trunk/src/waeup/ikoba/customers/export.py
===================================================================
--- /main/waeup.ikoba/trunk/src/waeup/ikoba/customers/export.py	(revision 12282)
+++ /main/waeup.ikoba/trunk/src/waeup/ikoba/customers/export.py	(revision 12283)
@@ -247,3 +247,3 @@
     iface = ISampleContract
     class_name = 'SampleContract'
-    title = _(u'Sample Contracts')
+    title = _(u'Customer Sample Contracts')
Index: /main/waeup.ikoba/trunk/src/waeup/ikoba/customers/tests/test_batching.py
===================================================================
--- /main/waeup.ikoba/trunk/src/waeup/ikoba/customers/tests/test_batching.py	(revision 12282)
+++ /main/waeup.ikoba/trunk/src/waeup/ikoba/customers/tests/test_batching.py	(revision 12283)
@@ -502,5 +502,5 @@
             if len(i) > 10][0]
         self.assertTrue(
-            'INFO - system - Sample Contract Processor - sample_contract_data - '
+            'INFO - system - Customer Sample Contract Processor - sample_contract_data - '
             'X666666 - %s - updated: title=My 4th contract, '
             'product_object=SAM, document_object=DOC1' % conid
Index: /main/waeup.ikoba/trunk/src/waeup/ikoba/utils/utils.py
===================================================================
--- /main/waeup.ikoba/trunk/src/waeup/ikoba/utils/utils.py	(revision 12282)
+++ /main/waeup.ikoba/trunk/src/waeup/ikoba/utils/utils.py	(revision 12283)
@@ -29,4 +29,5 @@
 from waeup.ikoba.smtp import send_mail as send_mail_internally
 from waeup.ikoba.utils.helpers import get_sorted_preferred
+from waeup.ikoba.customers.export import EXPORTER_NAMES as CUSTOMER_EXPORTER_NAMES
 
 
@@ -137,4 +138,19 @@
         'cpu-load': 100.0,
         }
+
+    EXPORTER_NAMES = CUSTOMER_EXPORTER_NAMES + (
+        'pdfdocuments',
+        'htmldocuments',
+        'users',
+        'products')
+
+    BATCH_PROCESSOR_NAMES = (
+        'customerprocessor',
+        'customersampledocumentprocessor',
+        'samplecontractprocessor',
+        'productprocessor',
+        'pdfdocumentprocessor',
+        'htmldocumentprocessor',
+        'userprocessor')
 
     def sendContactForm(self, from_name, from_addr, rcpt_name, rcpt_addr,