Index: main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/batching.py
===================================================================
--- main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/batching.py	(revision 12282)
+++ main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/batching.py	(revision 12284)
@@ -20,11 +20,22 @@
 import grok
 from waeup.ikoba.customers.batching import (
-    CustomerDocumentProcessor, ContractProcessor)
+    CustomerProcessor,
+    CustomerDocumentProcessorBase, ContractProcessorBase)
 from ikobacustom.skeleton.customers.interfaces import (
+    ISkeletonCustomer,
     ISkeletonCustomerDocument, ISkeletonContract)
 from ikobacustom.skeleton.interfaces import MessageFactory as _
 
 
-class SkeletonCustomerDocumentProcessor(CustomerDocumentProcessor):
+class SkeletonCustomerProcessor(CustomerProcessor):
+    """A batch processor for ICustomer objects.
+    """
+    util_name = 'skeletoncustomerprocessor'
+    grok.name(util_name)
+    name = _('Skeleton Customer Processor')
+    iface = ISkeletonCustomer
+
+
+class SkeletonCustomerDocumentProcessor(CustomerDocumentProcessorBase):
     """A batch processor for ISkeletonCustomerDocument objects.
     """
@@ -36,10 +47,10 @@
 
 
-class SkeletonContractProcessor(ContractProcessor):
+class SkeletonContractProcessor(ContractProcessorBase):
     """A batch processor for ISkeletonContract objects.
     """
     util_name = 'skeletoncontractprocessor'
     grok.name(util_name)
-    name = _('Skeleton Contract Processor')
+    name = _('Skeleton Customer Contract Processor')
     iface = ISkeletonContract
     factory_name = 'waeup.SkeletonContract'
Index: main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/export.py
===================================================================
--- main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/export.py	(revision 12282)
+++ main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/export.py	(revision 12284)
@@ -26,4 +26,5 @@
 from ikobacustom.skeleton.interfaces import MessageFactory as _
 
+EXPORTER_NAMES = ('customers', 'skeletoncustomerdocuments', 'skeletoncontracts')
 
 class SkeletonCustomerExporter(CustomerExporter):
@@ -48,4 +49,4 @@
     grok.name('skeletoncontracts')
     iface = ISkeletonContract
-    title = _(u'Skeleton Contracts')
+    title = _(u'Skeleton Customer Contracts')
     class_name = 'SkeletonContract'
Index: main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/products/batching.py
===================================================================
--- main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/products/batching.py	(revision 12282)
+++ main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/products/batching.py	(revision 12284)
@@ -18,4 +18,5 @@
 """Batch processing for skeleton products.
 """
+import grok
 from waeup.ikoba.products.batching import ProductProcessor
 from ikobacustom.skeleton.products.interfaces import ISkeletonProduct
@@ -25,4 +26,5 @@
 
     iface = ISkeletonProduct
-
-    #name = _('SkeletonProduct Processor')
+    name = _('Skeleton Product Processor')
+    util_name = 'skeletonproductprocessor'
+    grok.name(util_name)
Index: main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/utils/utils.py
===================================================================
--- main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/utils/utils.py	(revision 12282)
+++ main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/utils/utils.py	(revision 12284)
@@ -21,4 +21,5 @@
 import pytz
 from waeup.ikoba.utils.utils import IkobaUtils, sorted_phone_prefixes
+from ikobacustom.skeleton.customers.export import EXPORTER_NAMES as CUSTOMER_EXPORTER_NAMES
 from ikobacustom.skeleton.interfaces import MessageFactory as _
 
@@ -48,4 +49,19 @@
         }
 
+    EXPORTER_NAMES = CUSTOMER_EXPORTER_NAMES + (
+        'pdfdocuments',
+        'htmldocuments',
+        'users',
+        'products')
+
+    BATCH_PROCESSOR_NAMES = (
+        'skeletoncustomerprocessor',
+        'skeletoncustomerdocumentprocessor',
+        'skeletoncontractprocessor',
+        'skeletonproductprocessor',
+        'pdfdocumentprocessor',
+        'htmldocumentprocessor',
+        'userprocessor')
+
     #: A function to return
     @classmethod