Index: /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/batching.py
===================================================================
--- /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/batching.py	(revision 12285)
+++ /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/batching.py	(revision 12286)
@@ -1,3 +1,3 @@
-## $Id: batching.py 12269 2014-12-20 16:12:59Z henrik $
+## $Id$
 ##
 ## Copyright (C) 2011 Uli Fouquet & Henrik Bettermann
Index: /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/contracts.py
===================================================================
--- /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/contracts.py	(revision 12285)
+++ /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/contracts.py	(revision 12286)
@@ -1,3 +1,3 @@
-## $Id: contracts.py 12258 2014-12-18 14:44:30Z henrik $
+## $Id$
 ##
 ## Copyright (C) 2014 Uli Fouquet & Henrik Bettermann
Index: /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/documents.py
===================================================================
--- /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/documents.py	(revision 12285)
+++ /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/documents.py	(revision 12286)
@@ -1,3 +1,3 @@
-## $Id: documents.py 12256 2014-12-18 12:58:12Z henrik $
+## $Id$
 ##
 ## Copyright (C) 2014 Uli Fouquet & Henrik Bettermann
Index: /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/export.py
===================================================================
--- /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/export.py	(revision 12285)
+++ /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/export.py	(revision 12286)
@@ -1,3 +1,3 @@
-## $Id: export.py 12270 2014-12-20 16:36:18Z henrik $
+## $Id$
 ##
 ## Copyright (C) 2014 Uli Fouquet & Henrik Bettermann
Index: /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/tests/test_browser.py
===================================================================
--- /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/tests/test_browser.py	(revision 12285)
+++ /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/tests/test_browser.py	(revision 12286)
@@ -1,3 +1,3 @@
-## $Id: test_browser.py 12269 2014-12-20 16:12:59Z henrik $
+## $Id$
 ##
 ## Copyright (C) 2014 Uli Fouquet & Henrik Bettermann
Index: /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/tests/test_contract.py
===================================================================
--- /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/tests/test_contract.py	(revision 12285)
+++ /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/tests/test_contract.py	(revision 12286)
@@ -1,3 +1,3 @@
-## $Id: test_contract.py 12259 2014-12-18 15:47:12Z henrik $
+## $Id$
 ##
 ## Copyright (C) 2014 Uli Fouquet & Henrik Bettermann
Index: /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/tests/test_document.py
===================================================================
--- /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/tests/test_document.py	(revision 12285)
+++ /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/tests/test_document.py	(revision 12286)
@@ -1,3 +1,3 @@
-## $Id: test_document.py 12259 2014-12-18 15:47:12Z henrik $
+## $Id$
 ##
 ## Copyright (C) 2014 Uli Fouquet & Henrik Bettermann
Index: /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/utils.py
===================================================================
--- /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/utils.py	(revision 12285)
+++ /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/utils.py	(revision 12286)
@@ -1,3 +1,3 @@
-## $Id: utils.py 12223 2014-12-14 08:49:01Z henrik $
+## $Id$
 ##
 ## Copyright (C) 2014 Uli Fouquet & Henrik Bettermann