Index: main/waeup.ikoba/trunk/src/waeup/ikoba/documents/export.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/documents/export.py	(revision 12268)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/documents/export.py	(revision 12287)
@@ -38,6 +38,14 @@
     @property
     def fields(self):
-        return tuple(sorted(iface_names(self.iface))) + (
-        'users_with_local_roles',)
+        return tuple(sorted(iface_names(self.iface, exclude_attribs=False,
+            omit=['is_verifiable',
+                  'translated_state',
+                  'user_id',
+                  'formatted_transition_date',
+                  'translated_class_name',
+                  'connected_files',   # Could be used to export file URLs
+                  ]
+            ))) + (
+            'users_with_local_roles',)
 
     def mangle_value(self, value, name, context=None):
@@ -49,4 +57,6 @@
             for local_role, user_name, setting in role_map.getPrincipalsAndRoles():
                 value.append({'user_name':user_name,'local_role':local_role})
+        if name == 'history':
+            value = value.messages
         return super(DocumentExporterBase, self).mangle_value(
             value, name, context)
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/documents/tests/test_export.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/documents/tests/test_export.py	(revision 12268)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/documents/tests/test_export.py	(revision 12287)
@@ -62,8 +62,10 @@
         exporter.export([self.pdfdocument], self.outfile)
         result = open(self.outfile, 'rb').read()
-        self.assertTrue(
-            'description,document_id,title,users_with_local_roles\r\n'
-            ',DOC1,,"[{\'user_name\': u\'john\', \'local_role\': u\'johnsrole\'}]"'
-            in result
+        self.assertMatches(
+            'class_name,description,document_id,history,state,title,users_with_local_roles\r\n'
+            'PDFDocument,,DOC1,'
+            '[u\'2014-12-21 16:55:16 UTC - Document created by system\'],'
+            'created,,"[{\'user_name\': u\'john\', \'local_role\': u\'johnsrole\'}]"',
+            result
             )
         return
@@ -74,8 +76,10 @@
         exporter.export_all(self.app, self.outfile)
         result = open(self.outfile, 'rb').read()
-        self.assertTrue(
-            'description,document_id,title,users_with_local_roles\r\n'
-            ',DOC1,,"[{\'user_name\': u\'john\', \'local_role\': u\'johnsrole\'}]"'
-            in result
+        self.assertMatches(
+            'class_name,description,document_id,history,state,title,users_with_local_roles\r\n'
+            'PDFDocument,,DOC1,'
+            '[u\'2014-12-21 16:55:16 UTC - Document created by system\'],'
+            'created,,"[{\'user_name\': u\'john\', \'local_role\': u\'johnsrole\'}]"',
+            result
             )
         return
@@ -109,10 +113,11 @@
         exporter.export([self.htmldocument], self.outfile)
         result = open(self.outfile, 'rb').read()
-        self.assertTrue(
-            'description,document_id,html_multilingual,title,'
-            'users_with_local_roles\r\n,DOC2,'
-            ',,'
-            '"[{\'user_name\': u\'john\', \'local_role\': u\'johnsrole\'}]"\r\n'
-            in result
+        self.assertMatches(
+            'class_name,description,document_id,history,html_dict,'
+            'html_multilingual,state,title,users_with_local_roles\r\n'
+            'HTMLDocument,,DOC2,'
+            '[u\'2014-12-21 16:50:28 UTC - Document created by system\'],'
+            '{},,created,,"[{\'user_name\': u\'john\', \'local_role\': u\'johnsrole\'}]"',
+            result
             )
         return
@@ -123,10 +128,11 @@
         exporter.export_all(self.app, self.outfile)
         result = open(self.outfile, 'rb').read()
-        self.assertTrue(
-            'description,document_id,html_multilingual,title,'
-            'users_with_local_roles\r\n,DOC2,'
-            ',,'
-            '"[{\'user_name\': u\'john\', \'local_role\': u\'johnsrole\'}]"\r\n'
-            in result
+        self.assertMatches(
+            'class_name,description,document_id,history,html_dict,'
+            'html_multilingual,state,title,users_with_local_roles\r\n'
+            'HTMLDocument,,DOC2,'
+            '[u\'2014-12-21 16:50:28 UTC - Document created by system\'],'
+            '{},,created,,"[{\'user_name\': u\'john\', \'local_role\': u\'johnsrole\'}]"',
+            result
             )
         return