Index: /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/export.py
===================================================================
--- /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/export.py	(revision 12291)
+++ /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/export.py	(revision 12292)
@@ -19,5 +19,4 @@
 """
 import grok
-from waeup.ikoba.utils.helpers import iface_names
 from waeup.ikoba.customers.export import (
     CustomerExporter, CustomerDocumentExporterBase, ContractExporterBase)
Index: /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/interfaces.py
===================================================================
--- /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/interfaces.py	(revision 12291)
+++ /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/interfaces.py	(revision 12292)
@@ -21,5 +21,4 @@
     ICustomer, ICustomerDocument, IContract)
 from waeup.ikoba.customers.vocabularies import (
-    contextual_reg_num_source, GenderSource, nats_vocab,
     ConCatProductSource, CustomerDocumentSource)
 from ikobacustom.skeleton.interfaces import MessageFactory as _
Index: /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/tests/test_browser.py
===================================================================
--- /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/tests/test_browser.py	(revision 12291)
+++ /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/tests/test_browser.py	(revision 12292)
@@ -29,5 +29,4 @@
 from hurry.workflow.interfaces import IWorkflowState
 from waeup.ikoba.customers.tests.test_batching import CustomerImportExportSetup
-from ikobacustom.skeleton.customers.documents import SkeletonCustomerDocument
 from ikobacustom.skeleton.customers.export import (
     SkeletonCustomerExporter,
Index: /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/tests/test_contract.py
===================================================================
--- /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/tests/test_contract.py	(revision 12291)
+++ /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/tests/test_contract.py	(revision 12292)
@@ -25,8 +25,5 @@
 from zope.component.hooks import setSite
 from zope.interface import verify
-from waeup.ikoba.app import Company
 from waeup.ikoba.customers.interfaces import ICustomerNavigation
-from waeup.ikoba.customers.interfaces import (
-    ICustomersContainer, ICustomerNavigation)
 from waeup.ikoba.customers.contracts import ContractsContainer
 
Index: /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/tests/test_document.py
===================================================================
--- /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/tests/test_document.py	(revision 12291)
+++ /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/customers/tests/test_document.py	(revision 12292)
@@ -25,8 +25,5 @@
 from zope.component.hooks import setSite
 from zope.interface import verify
-from waeup.ikoba.app import Company
 from waeup.ikoba.customers.interfaces import ICustomerNavigation
-from waeup.ikoba.customers.interfaces import (
-    ICustomersContainer, ICustomerNavigation)
 from waeup.ikoba.customers.documents import CustomerDocumentsContainer
 
Index: /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/documents/export.py
===================================================================
--- /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/documents/export.py	(revision 12291)
+++ /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/documents/export.py	(revision 12292)
@@ -19,5 +19,4 @@
 """
 import grok
-from waeup.ikoba.utils.helpers import iface_names
 from waeup.ikoba.documents.export import DocumentExporterBase
 from ikobacustom.skeleton.documents.interfaces import ISkeletonDocument
Index: /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/documents/interfaces.py
===================================================================
--- /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/documents/interfaces.py	(revision 12291)
+++ /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/documents/interfaces.py	(revision 12292)
@@ -16,9 +16,4 @@
 ## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 ##
-from zope.interface import Attribute, Interface
-from zope import schema
-from waeup.ikoba.interfaces import (
-    IIkobaObject,
-    ContextualDictSourceFactoryBase)
 from waeup.ikoba.documents.interfaces import IPublicDocument
 from ikobacustom.skeleton.interfaces import MessageFactory as _
Index: /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/documents/tests/test_document.py
===================================================================
--- /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/documents/tests/test_document.py	(revision 12291)
+++ /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/documents/tests/test_document.py	(revision 12292)
@@ -21,5 +21,4 @@
 from zope.interface.verify import verifyClass, verifyObject
 from zope.component import createObject
-from waeup.ikoba.documents.interfaces import IDocumentsContainer
 from waeup.ikoba.documents.container import DocumentsContainer
 
Index: /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/documents/utils.py
===================================================================
--- /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/documents/utils.py	(revision 12291)
+++ /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/documents/utils.py	(revision 12292)
@@ -18,5 +18,4 @@
 """General helper functions and utilities for the documents.
 """
-import grok
 from waeup.ikoba.documents.utils import DocumentsUtils
 from ikobacustom.skeleton.interfaces import MessageFactory as _
Index: /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/products/interfaces.py
===================================================================
--- /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/products/interfaces.py	(revision 12291)
+++ /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/products/interfaces.py	(revision 12292)
@@ -16,9 +16,4 @@
 ## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 ##
-from zope.interface import Attribute, Interface
-from zope import schema
-from waeup.ikoba.interfaces import (
-    IIkobaObject,
-    ContextualDictSourceFactoryBase)
 from waeup.ikoba.products.interfaces import IProduct
 from ikobacustom.skeleton.interfaces import MessageFactory as _
Index: /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/utils/utils.py
===================================================================
--- /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/utils/utils.py	(revision 12291)
+++ /main/ikobacustom.skeleton/trunk/src/ikobacustom/skeleton/utils/utils.py	(revision 12292)
@@ -18,5 +18,4 @@
 """Customize general helper utilities for Ikoba.
 """
-import os
 import pytz
 from waeup.ikoba.utils.utils import IkobaUtils, sorted_phone_prefixes