Index: main/waeup.ikoba/trunk/src/waeup/ikoba/customers/customer.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/customers/customer.py	(revision 12296)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/customers/customer.py	(revision 12297)
@@ -37,5 +37,4 @@
     IIkobaUtils, IExtFileStore,
     CREATED, REQUESTED, APPROVED)
-from waeup.ikoba.customers.export import EXPORTER_NAMES
 from waeup.ikoba.customers.interfaces import (
     ICustomer, ICustomerNavigation, ICSVCustomerExporter,
@@ -233,5 +232,5 @@
     (column `del_date`) as a UTC timestamp.
     """
-    for name in EXPORTER_NAMES:
+    for name in getUtility(ICustomersUtils).EXPORTER_NAMES:
         exporter = getUtility(ICSVCustomerExporter, name=name)
         csv_data = exporter.export_customer(customer)
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/customers/export.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/customers/export.py	(revision 12296)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/customers/export.py	(revision 12297)
@@ -32,9 +32,4 @@
 from waeup.ikoba.utils.helpers import iface_names, to_timezone
 
-#: A tuple containing all exporter names referring to customers or
-#: subobjects thereof.
-EXPORTER_NAMES = ('customers', 'customersampledocuments', 'samplecontracts')
-
-
 def get_customers(site, cust_filter=CustomersQuery()):
     """Get all customers registered in catalog in `site`.
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/customers/tests/test_customer.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/customers/tests/test_customer.py	(revision 12296)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/customers/tests/test_customer.py	(revision 12297)
@@ -31,9 +31,8 @@
 from zope.schema.interfaces import RequiredMissing
 from waeup.ikoba.interfaces import IExtFileStore, IFileStoreNameChooser
-from waeup.ikoba.customers.export import EXPORTER_NAMES
 from waeup.ikoba.customers.customer import (
     Customer, CustomerFactory, handle_customer_removed, path_from_custid)
 from waeup.ikoba.customers.interfaces import (
-    ICustomer, ICustomerNavigation)
+    ICustomer, ICustomerNavigation, ICustomersUtils)
 from waeup.ikoba.customers.tests.test_batching import CustomerImportExportSetup
 from waeup.ikoba.testing import FunctionalLayer, FunctionalTestCase
@@ -136,5 +135,5 @@
 
         # The customer data were put into CSV files
-        for name in EXPORTER_NAMES:
+        for name in getUtility(ICustomersUtils).EXPORTER_NAMES:
             csv_path = os.path.join(del_dir, '%s.csv' % name)
             self.assertTrue(os.path.isfile(csv_path))
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/customers/utils.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/customers/utils.py	(revision 12296)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/customers/utils.py	(revision 12297)
@@ -333,4 +333,6 @@
     SELECTABLE_CONTYPES_DICT = CONTYPES_DICT
 
+    EXPORTER_NAMES = ('customers', 'customersampledocuments', 'samplecontracts')
+
     def getPDFCreator(self, context=None):
         """Get a pdf creator suitable for `context`.
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/utils/utils.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/utils/utils.py	(revision 12296)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/utils/utils.py	(revision 12297)
@@ -29,5 +29,4 @@
 from waeup.ikoba.smtp import send_mail as send_mail_internally
 from waeup.ikoba.utils.helpers import get_sorted_preferred
-from waeup.ikoba.customers.export import EXPORTER_NAMES as CUSTOMER_EXPORTER_NAMES
 
 
@@ -139,9 +138,12 @@
         }
 
-    EXPORTER_NAMES = CUSTOMER_EXPORTER_NAMES + (
+    EXPORTER_NAMES = (
         'pdfdocuments',
         'htmldocuments',
         'users',
-        'products')
+        'products',
+        'customers',
+        'customersampledocuments',
+        'samplecontracts')
 
     BATCH_PROCESSOR_NAMES = (